package com.maroontress.madangler.client;

import com.google.gwt.user.client.History;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.Widget;

/**
   ʥӥ󥯤¤٤ѥͥǤ
*/
public class NavigationPanel extends SimplePanel {

    /** ʥӥ֤α */
    private static final String RIGHT_ARROW =
	"&nbsp;<img src=\"images/right-arrow.png\">&nbsp;";

    /** ʥӥΥå */
    private NavigationStack stack;

    /** ʥӥꥹ */
    private NavigationListener naviListener;

    /**
       ʥӥѥͥޤ
    */
    public NavigationPanel() {
	stack = new NavigationStack();
    }

    /**
       ʥӥΥåƤǥѥͥľޤ
    */
    private void updateStack() {
	HorizontalPanel hp = new HorizontalPanel();
	int k, n = stack.size();

	for (k = 0; k < n - 1; ++k) {
	    final Navigation navi = stack.get(k);
	    HTML html = new HTML(navi.getTitle());
	    html.setStyleName("linkHTML");
	    html.addClickListener(new ClickListener() {
		public void onClick(final Widget sender) {
		    if (!naviListener.navigationClicked()) {
			return;
		    }
		    stack.popOver(navi);
		    History.newItem(stack.pop().getLink().encode());
		}
	    });
	    hp.add(html);
	    hp.add(new HTML(RIGHT_ARROW));
	}
	Navigation lastNavi = stack.get(k);
	hp.add(new HTML("<b>" + lastNavi.getTitle() + "</b>"));
	setWidget(hp);
    }

    /**
       ʥӥ򥹥åѤǥѥͥľޤ

       @param navi ʥӥ
    */
    public void push(final Navigation navi) {
	stack.push(navi);
	updateStack();
    }

    /**
       ʥӥ򥹥åФФʥӥ
       Υ󥯤URL򹹿ޤ

       ѥͥƤѹޤ
    */
    public void pop() {
	stack.pop();
	History.newItem(stack.pop().getLink().encode());
    }

    /**
       ʥӥ򥹥åФƼΤơꤷʥӥ
       Υ󥯤URL򹹿ޤ

       ѥͥƤѹޤ

       @param navi ʥӥ
    */
    public void replace(final Navigation navi) {
	stack.pop();
	History.newItem(navi.getLink().encode());
    }

    /**
       åˤʥӥ򤹤٤Ƽޤ

       ѥͥƤѹޤ
    */
    public void clearNavigation() {
	stack.clear();
    }

    /**
       ʥӥꥹʤꤷޤ

       @param naviListener ʥӥꥹ
    */
    public void setNavigationListener(final NavigationListener naviListener) {
	this.naviListener = naviListener;
    }
}
