package com.maroontress.madangler.client.config;

import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.maroontress.madangler.client.MadAngler;
import com.maroontress.madangler.client.Dialog;
import com.maroontress.madangler.client.TextBoxPanel;

/**
   ץåȥեIDѹǤ
*/
public class PlatformRenamer extends Dialog {

    /** 󥻥Υܥ */
    private Button cancelButton;

    /** Υܥ */
    private Button okButton;

    /** ץΥǥ */
    private ConfigModel model;

    /** ץåȥեID */
    private TextBoxPanel id;

    /** ץåȥեΥǥå */
    private int index;

    /**
       ץåȥեIDѹޤ

       @param model ץΥǥ
    */
    public PlatformRenamer(final ConfigModel model) {
	this.model = model;
	index = -1;

	setText("Rename a platform");

	id = new TextBoxPanel("Platform ID", 32);

	cancelButton = new Button("Cancel");
	cancelButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		hide();
	    }
	});

	okButton = new Button("Ok");
	okButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		renamePlatform();
	    }
	});

	HorizontalPanel bp = new HorizontalPanel();
	HTML space = new HTML("&nbsp;");
	bp.add(cancelButton);
	bp.add(space);
	bp.add(okButton);
	bp.setCellWidth(space, "100%");
	bp.setWidth("100%");

	VerticalPanel vp = new VerticalPanel();
	vp.add(new HTML("&nbsp;"));
	vp.add(id);
	vp.add(new HTML("&nbsp;"));
	vp.add(bp);

	setWidget(vp);
    }

    /**
       ץåȥեΥǥåꤷޤ

       @param i ץåȥեΥǥå
    */
    public void setPlatformIndex(final int i) {
	index = i;
	Platform p = model.getPlatform(index);
	id.setText(p.getId());
    }

    /**
       ʸζޤ

       ζʸ󤬶ξϥǷٹ𤷡
       null֤ޤ

       @param s ζʸ
       @param label ٹ𤹤ȤɽʸΥ٥
       @return ʸ󡢷̤ξnull
    */
    private String trim(final String s, final String label) {
	// PlatformDialog.trim()Ȱ
	String t = s.trim();
	if (t.equals("")) {
	    MadAngler.alert(label + " is empty.");
	    return null;
	}
	return t;
    }

    /**
       ץåȥե̾ޤ
    */
    private void renamePlatform() {
	String idString = trim(id.getText(), "Platform ID");
	if (idString == null) {
	    return;
	}
	Platform p = model.getPlatform(index);
	String id = p.getId();
	String host = p.getHost();
	String command = p.getCommand();
	String charset = p.getCharset();
	if (id.equals(idString)) {
	    hide();
	    return;
	}
	if (model.getPlatformById(idString) != null) {
	    MadAngler.alert("'" + idString + "' already exists.");
	    return;
	}
	p = new Platform(idString, host, command, charset);
	model.setPlatform(index, p);
	model.notifyChanged();
	hide();
    }
}
